Program Pontok;
{Ertekel a Pontok feladathoz}
Uses TestLib;
{Importlt elemek:
TCase:Integer;           a tesztesetek szma
Function DoTest:Boolean; a teszteset rtkelhet, van output fjl
Procedure Done;          az rtkels vgnek jelzse
Procedure Grade(rf, v:Integer); az rf rszfeladat rtklse, v=0/1
                                ha nem hvjuk, 0 rtket kap a teszeset
Procedure WriteMSG(rf:Integer; M:String); az rf rszfeladat rtkelsnekmagyarzata
            ha nem hvjuk, resen marad
TInF:Text;  teszt input, megnyitva
ToutF:Text; teszt output, megnyitva
CoutF:Text; a versenyz output llomnya, megnyitva
}
Const
  MaxN=10000;
  MaxV=10000;
Var
{  Int:Array[1..MaxV] of Rekord K,V:Word End;}
  t:Integer;
Procedure Eval;
Type
  Pont=Record x,y:Integer End;
Function ForgasIrany(P0,P1,P2:Pont):Integer;
 {Kimenet: -1 ha P1-P2 balra fordul,
            0 ha P0,P1 s P2 kollinerisak,
           +1 ha P1-P2 jobbra fordul.}
Var
  KeresztSzorz:Longint;
Begin{ForgasIrany}
  KeresztSzorz:=(Longint(P1.y)-P0.y)*(Longint(P2.x)-P0.x)-
                (Longint(P2.y)-P0.y)*(Longint(P1.x)-P0.x);
  If KeresztSzorz < 0 Then
    ForgasIrany:=-1
  Else If KeresztSzorz>0 Then
    ForgasIrany:=1
  Else
    ForgasIrany:=0;
End{ForgasIrany};

{  PontHalmaz=Array[1..MaxN] of Pont;}
Var
  N,i: Longint;
  P:Pont;
  P1,P2,Q1,Q2,R1,R2:Pont;
  x1,y1,x2,y2:Longint;
  vx1,vy1,vx2,vy2:Longint;
  OK:Boolean;
Begin{Eval}
  ReadLn(TinF, N);
  ReadLn(ToutF, x1,y1,x2,y2);
  {$I-}
    ReadLn(CoutF, vx1,vy1,vx2,vy2);
   {$I+}
   If IOResult<>0 Then Begin
     WriteMSG(1,'HIBA: Output formtum hiba');
     Exit;
   End;
   If (x1=0)And(y1=0)And(x2=0)And(y2=0) Then Begin
     If Not ((vx1=0)And(vy1=0)And(vx2=0)And(vy2=0))Then Begin
       WriteMSG(1,'HIBA: Hibs kimenet');
       Exit;
     End else begin
     Grade(1,1);
     WriteMSG(1,'HELYES');
     end;
   End;
   P1.x:=vx1; P1.y:=vy1; P2.x:=vx2; P2.y:=vy2;

   {$I-}
    ReadLn(CoutF, x1,y1,x2,y2);
   {$I+}
   If IOResult<>0 Then Begin
     WriteMSG(1,'HIBA: Output formtum hiba');
     Exit;
   End;
    Q1.x:=x1; Q1.y:=y1; Q2.x:=x2; Q2.y:=y2;
   {$I-}
     ReadLn(CoutF, x1,y1,x2,y2);
   {$I+}
   If IOResult<>0 Then Begin
     WriteMSG(1,'HIBA: Output formtum hiba');
     Exit;
   End;
   R1.x:=x1; R1.y:=y1; R2.x:=x2; R2.y:=y2;

   For i:=1 To N Do Begin
     ReadLn(TinF, P.x,P.y);
     OK:=((P1.x<>P2.x)Or(P1.y<>P2.y)) And (ForgasIrany(P1,P2,P)=0)Or
         ((R1.x<>R2.x)Or(R1.y<>R2.y)) And (ForgasIrany(R1,R2,P)=0)Or
         ((Q1.x<>Q2.x)Or(Q1.y<>Q2.y)) And (ForgasIrany(Q1,Q2,P)=0);
     If Not OK Then Begin
       WriteMSG(1,'HIBA: Pont nem esik egyik egyenesre sem');
       Exit;
     End;
   End;

   Grade(1,1);
   WriteMSG(1,'HELYES');
End{Eval};

Begin{Prog}
  For t:=1 To TCase Do Begin
    If DoTest Then
      Eval;
  End;
  Done;
End.
